标签:leetcode
Given a collection of integers that might contain duplicates,S, return all possible subsets.
Note:
For example,
If S =[1,2,2]
, a solution is:
[
[2],
[1],
[1,2,2],
[2,2],
[1,2],
[]
]
解题思路:
思路跟Subset i一样,不过这里需要特别处理一下的是集合中存在重复元素的情况.
我们先来看下样例的状态树:
从上面图中,我们可以发现,从根到叶子节点即是所要求的集合的一个子集,但问题就在于
某些从根到叶子节点的集合相同,而我们只需要其中一个,那我们怎么去重?我们看下图中
红色和蓝色标记的部分,从根到它们的父节点上的路径肯定是相同的,而由于第2号元素和第3号
元素重复,导致了红色部分的右支和蓝色部分的左支结果相同,所以这种情况里面,我们只需要保留
一种即可.故这里只需要引进一个bool变量,用于标记当前节点的右支是否需要进行搜索,就能去重了.
解题代码:
class Solution { public: void dfs(vector<int> &S, bool flag, int pos, vector<int> &path,vector<vector<int> > &res) { if (pos >= S.size()) { res.push_back(vector<int>(path.begin(),path.end())); return; } dfs(S, pos + 1 < S.size() && S[pos] != S[pos+1], pos + 1, path, res); path.push_back(S[pos]); if (flag) dfs(S, true, pos + 1, path,res); path.pop_back(); } vector<vector<int> > subsetsWithDup(vector<int> &S) { sort(S.begin(),S.end()); vector<vector<int> > res; vector<int> path; dfs(S,true,0,path,res); return res; } };
LeetCode:Subsets II,布布扣,bubuko.com
标签:leetcode
原文地址:http://blog.csdn.net/dream_you_to_life/article/details/33347231